#structure voids
execute as @a at @s if block ~ ~ ~ structure_void if score level stats matches 5 run effect give @s minecraft:slow_falling 2 20 true
execute as @a at @s unless block ~ ~ ~ structure_void run effect clear @s minecraft:slow_falling

#death
execute as @a[gamemode=adventure] at @s if score @s y matches ..87 run tag @s add death
execute as @a[gamemode=spectator] at @s if score @s y matches ..87 run teleport @s ~ ~1 ~

execute as @a[gamemode=adventure] at @s if score @s deaths matches 1.. run tag @s add death

#respawn
execute as @a[tag=death] at @s run particle minecraft:cloud ~ ~0.5 ~ 0.5 1 0.5 0.1 100
execute if score respawn stats matches 1 as @a[tag=death] run teleport @s @e[type=area_effect_cloud,name=current_level,limit=1]
execute if score respawn stats matches 1 as @a[tag=death] run effect give @s instant_health 1 100 true
execute if score respawn stats matches 1 as @a[tag=death] run effect give @s slow_falling 1 100 true

execute if score respawn stats matches 0 as @a[tag=death] run teleport @s 0 110 0
execute if score respawn stats matches 0 as @a[tag=death] unless score @s deaths matches 1.. unless score @s drown matches 1.. run tellraw @a ["",{"selector":"@a[tag=death]"},{"text":" fell out of the map","color":"white"}]
execute if score respawn stats matches 0 as @a[tag=death] run gamemode spectator @s

execute as @a[tag=death] at @s run playsound minecraft:entity.villager.death master @s ~ ~ ~ 5 0

tag @a[tag=death] remove death
scoreboard players reset @a deaths

#time track
scoreboard players add @a seconds 0
scoreboard players add @a minutes 0
execute as @a run scoreboard players add @s ticks 1
execute as @a[scores={ticks=20..}] run scoreboard players add @s seconds 1
execute as @a[scores={seconds=60..}] run scoreboard players add @s minutes 1
scoreboard players set @a[scores={ticks=20..}] ticks 0
scoreboard players set @a[scores={seconds=60..}] seconds 0

#timer
execute if score practice stats matches 0 run function sette:game/time
execute if score practice stats matches 1 run function sette:game/practice

#finish button
execute as @a[tag=finished] run scoreboard players operation $last seconds = @s seconds
execute as @a[tag=finished] run scoreboard players operation $last minutes = @s minutes

execute as @a[tag=finished] at @s unless entity @s[tag=end_sound] run playsound minecraft:block.note_block.banjo master @s ~ ~ ~ 5 1
execute as @a[tag=finished] at @s if entity @s[tag=end_sound] run playsound minecraft:entity.ender_dragon.growl master @s ~ ~ ~ 300 2

execute as @a[tag=finished] at @s if score level stats matches 1 if score $last seconds matches 10.. run tellraw @a ["",{"selector":"@a[tag=finished]","color":"green"},{"text":" completed the level [","color":"gold"},{"score":{"name":"$last","objective":"minutes"},"color":"dark_aqua"},{"text":":","color":"aqua"},{"score":{"name":"$last","objective":"seconds"},"color":"dark_aqua"},{"text":"]. Well done!","color":"gold"}]
execute as @a[tag=finished] at @s if score level stats matches 2 if score $last seconds matches 10.. run tellraw @a ["",{"selector":"@a[tag=finished]","color":"green"},{"text":" completed the level [","color":"dark_green"},{"score":{"name":"$last","objective":"minutes"},"color":"dark_aqua"},{"text":":","color":"aqua"},{"score":{"name":"$last","objective":"seconds"},"color":"dark_aqua"},{"text":"]. Well done!","color":"dark_green"}]
execute as @a[tag=finished] at @s if score level stats matches 3 if score $last seconds matches 10.. run tellraw @a ["",{"selector":"@a[tag=finished]","color":"green"},{"text":" completed the level [","color":"blue"},{"score":{"name":"$last","objective":"minutes"},"color":"dark_aqua"},{"text":":","color":"aqua"},{"score":{"name":"$last","objective":"seconds"},"color":"dark_aqua"},{"text":"]. Well done!","color":"blue"}]
execute as @a[tag=finished] at @s if score level stats matches 4 if score $last seconds matches 10.. run tellraw @a ["",{"selector":"@a[tag=finished]","color":"green"},{"text":" completed the level [","color":"dark_gray"},{"score":{"name":"$last","objective":"minutes"},"color":"dark_aqua"},{"text":":","color":"aqua"},{"score":{"name":"$last","objective":"seconds"},"color":"dark_aqua"},{"text":"]. Well done!","color":"dark_gray"}]
execute as @a[tag=finished] at @s if score level stats matches 5 if score $last seconds matches 10.. run tellraw @a ["",{"selector":"@a[tag=finished]","color":"green"},{"text":" completed the level [","color":"yellow"},{"score":{"name":"$last","objective":"minutes"},"color":"dark_aqua"},{"text":":","color":"aqua"},{"score":{"name":"$last","objective":"seconds"},"color":"dark_aqua"},{"text":"]. Well done!","color":"yellow"}]
execute as @a[tag=finished] at @s if score level stats matches 6 if score $last seconds matches 10.. run tellraw @a ["",{"selector":"@a[tag=finished]","color":"green"},{"text":" completed the level [","color":"red"},{"score":{"name":"$last","objective":"minutes"},"color":"dark_aqua"},{"text":":","color":"aqua"},{"score":{"name":"$last","objective":"seconds"},"color":"dark_aqua"},{"text":"]. Well done!","color":"red"}]
execute as @a[tag=finished] at @s if score level stats matches 7 if score $last seconds matches 10.. run tellraw @a ["",{"selector":"@a[tag=finished]","color":"green"},{"text":" completed the level [","color":"aqua"},{"score":{"name":"$last","objective":"minutes"},"color":"dark_aqua"},{"text":":","color":"aqua"},{"score":{"name":"$last","objective":"seconds"},"color":"dark_aqua"},{"text":"]. Well done!","color":"aqua"}]
execute as @a[tag=finished] at @s if score level stats matches 8 if score $last seconds matches 10.. run tellraw @a ["",{"selector":"@a[tag=finished]","color":"green"},{"text":" completed the level [","color":"dark_purple"},{"score":{"name":"$last","objective":"minutes"},"color":"dark_aqua"},{"text":":","color":"aqua"},{"score":{"name":"$last","objective":"seconds"},"color":"dark_aqua"},{"text":"]. Well done!","color":"dark_purple"}]

execute as @a[tag=finished] at @s if score level stats matches 1 if score $last seconds matches 0..9 run tellraw @a ["",{"selector":"@a[tag=finished]","color":"green"},{"text":" completed the level [","color":"gold"},{"score":{"name":"$last","objective":"minutes"},"color":"dark_aqua"},{"text":":","color":"aqua"},{"text":"0","color":"dark_aqua"},{"score":{"name":"$last","objective":"seconds"},"color":"dark_aqua"},{"text":"]. Well done!","color":"gold"}]
execute as @a[tag=finished] at @s if score level stats matches 2 if score $last seconds matches 0..9 run tellraw @a ["",{"selector":"@a[tag=finished]","color":"green"},{"text":" completed the level [","color":"dark_green"},{"score":{"name":"$last","objective":"minutes"},"color":"dark_aqua"},{"text":":","color":"aqua"},{"text":"0","color":"dark_aqua"},{"score":{"name":"$last","objective":"seconds"},"color":"dark_aqua"},{"text":"]. Well done!","color":"dark_green"}]
execute as @a[tag=finished] at @s if score level stats matches 3 if score $last seconds matches 0..9 run tellraw @a ["",{"selector":"@a[tag=finished]","color":"green"},{"text":" completed the level [","color":"blue"},{"score":{"name":"$last","objective":"minutes"},"color":"dark_aqua"},{"text":":","color":"aqua"},{"text":"0","color":"dark_aqua"},{"score":{"name":"$last","objective":"seconds"},"color":"dark_aqua"},{"text":"]. Well done!","color":"blue"}]
execute as @a[tag=finished] at @s if score level stats matches 4 if score $last seconds matches 0..9 run tellraw @a ["",{"selector":"@a[tag=finished]","color":"green"},{"text":" completed the level [","color":"dark_gray"},{"score":{"name":"$last","objective":"minutes"},"color":"dark_aqua"},{"text":":","color":"aqua"},{"text":"0","color":"dark_aqua"},{"score":{"name":"$last","objective":"seconds"},"color":"dark_aqua"},{"text":"]. Well done!","color":"dark_gray"}]
execute as @a[tag=finished] at @s if score level stats matches 5 if score $last seconds matches 0..9 run tellraw @a ["",{"selector":"@a[tag=finished]","color":"green"},{"text":" completed the level [","color":"yellow"},{"score":{"name":"$last","objective":"minutes"},"color":"dark_aqua"},{"text":":","color":"aqua"},{"text":"0","color":"dark_aqua"},{"score":{"name":"$last","objective":"seconds"},"color":"dark_aqua"},{"text":"]. Well done!","color":"yellow"}]
execute as @a[tag=finished] at @s if score level stats matches 6 if score $last seconds matches 0..9 run tellraw @a ["",{"selector":"@a[tag=finished]","color":"green"},{"text":" completed the level [","color":"red"},{"score":{"name":"$last","objective":"minutes"},"color":"dark_aqua"},{"text":":","color":"aqua"},{"text":"0","color":"dark_aqua"},{"score":{"name":"$last","objective":"seconds"},"color":"dark_aqua"},{"text":"]. Well done!","color":"red"}]
execute as @a[tag=finished] at @s if score level stats matches 7 if score $last seconds matches 0..9 run tellraw @a ["",{"selector":"@a[tag=finished]","color":"green"},{"text":" completed the level [","color":"aqua"},{"score":{"name":"$last","objective":"minutes"},"color":"dark_aqua"},{"text":":","color":"aqua"},{"text":"0","color":"dark_aqua"},{"score":{"name":"$last","objective":"seconds"},"color":"dark_aqua"},{"text":"]. Well done!","color":"aqua"}]
execute as @a[tag=finished] at @s if score level stats matches 8 if score $last seconds matches 0..9 run tellraw @a ["",{"selector":"@a[tag=finished]","color":"green"},{"text":" completed the level [","color":"dark_purple"},{"score":{"name":"$last","objective":"minutes"},"color":"dark_aqua"},{"text":":","color":"aqua"},{"text":"0","color":"dark_aqua"},{"score":{"name":"$last","objective":"seconds"},"color":"dark_aqua"},{"text":"]. Well done!","color":"dark_purple"}]

execute as @a[tag=finished,tag=!mesa] at @s if score level stats matches 1 unless score practice stats matches 1 run function sette:game/unlock/mesa
execute as @a[tag=finished,tag=!jungle] at @s if score level stats matches 2 unless score practice stats matches 1 run function sette:game/unlock/jungle
execute as @a[tag=finished,tag=!ocean] at @s if score level stats matches 3 unless score practice stats matches 1 run function sette:game/unlock/ocean
execute as @a[tag=finished,tag=!cave] at @s if score level stats matches 4 unless score practice stats matches 1 run function sette:game/unlock/cave
execute as @a[tag=finished,tag=!desert] at @s if score level stats matches 5 unless score practice stats matches 1 run function sette:game/unlock/desert
execute as @a[tag=finished,tag=!nether] at @s if score level stats matches 6 unless score practice stats matches 1 run function sette:game/unlock/nether
execute as @a[tag=finished,tag=!ice_spikes] at @s if score level stats matches 7 unless score practice stats matches 1 run function sette:game/unlock/ice_spikes
execute as @a[tag=finished,tag=!end] at @s if score level stats matches 8 unless score practice stats matches 1 run function sette:game/unlock/end

effect clear @a[tag=finished]
execute unless score practice stats matches 1 run gamemode spectator @a[tag=finished]
execute if score practice stats matches 1 run teleport @a[tag=finished] @e[type=minecraft:area_effect_cloud,name=current_level,limit=1]
execute if score practice stats matches 1 as @a[tag=finished] run scoreboard players set @s minutes 0
execute if score practice stats matches 1 as @a[tag=finished] run scoreboard players set @s seconds 0

tag @a remove finished

#nether star
clear @a nether_star
kill @e[type=item,nbt={Item:{id:"minecraft:ender_pearl"}}]

#biome effects
#ice
particle minecraft:cloud 0 96 111 2.5 3 10 0.3 20
execute if entity @a[x=4,y=92,z=93,dx=-8,dy=10,dz=40] run scoreboard players add ice_effect stats 1
execute if score ice_effect stats matches 400.. run scoreboard players reset ice_effect stats
execute if score level stats matches 7 as @e[type=minecraft:area_effect_cloud,name=iceEffect] if score ice_effect stats matches 1 at @s run playsound minecraft:item.elytra.flying master @a[distance=..20] ~ ~ ~ 20 0
execute if score level stats matches 7 as @e[type=minecraft:area_effect_cloud,name=iceEffect] at @s if entity @a[gamemode=!spectator,distance=..20] run weather rain
execute if score level stats matches 7 as @e[type=minecraft:area_effect_cloud,name=iceEffect] at @s unless entity @a[gamemode=!spectator,distance=..21] run weather clear
execute if score level stats matches 7 as @a at @s if block ~ ~-1 ~ snow_block if score @s sneak matches 1.. if score ticks stats matches 1 run give @s snowball 1
execute if score level stats matches 7 as @a[scores={sneak=1..}] run scoreboard players reset @s sneak

#end biome
scoreboard players add @a loop 0
execute as @a[x=-119,y=120,z=123,dx=0,dy=0,dz=0] at @s run replaceitem entity @s armor.chest minecraft:elytra{HideFlags:1,Unbreakable:1b,Enchantments:[{id:"minecraft:binding_curse",lvl:1s}]} 1
execute as @e[type=area_effect_cloud,name=loop1] at @s run give @a[distance=..1,gamemode=!spectator,nbt=!{Inventory:[{id:"minecraft:firework_rocket",Count:1b}]}] minecraft:firework_rocket
execute as @e[type=area_effect_cloud,name=loop1] at @s run playsound minecraft:block.note_block.pling master @a[distance=..1.1,scores={loop=0}] ~ ~ ~ 10 1
execute as @e[type=area_effect_cloud,name=loop1] at @s run scoreboard players set @a[distance=..1,gamemode=!spectator,scores={loop=0}] loop 1
execute as @e[type=area_effect_cloud,name=loop2] at @s run playsound minecraft:block.note_block.pling master @a[distance=..1.1,scores={loop=1}] ~ ~ ~ 10 1.2
execute as @e[type=area_effect_cloud,name=loop2] at @s run scoreboard players set @a[distance=..1,gamemode=!spectator,scores={loop=1}] loop 2
execute as @e[type=area_effect_cloud,name=loop3] at @s run playsound minecraft:block.note_block.pling master @a[distance=..1.1,scores={loop=2}] ~ ~ ~ 10 1.4
execute as @e[type=area_effect_cloud,name=loop3] at @s run scoreboard players set @a[distance=..1,gamemode=!spectator,scores={loop=2}] loop 3
execute as @e[type=area_effect_cloud,name=loop4] at @s run playsound minecraft:block.note_block.pling master @a[distance=..1.1,scores={loop=3}] ~ ~ ~ 10 1.6
execute as @e[type=area_effect_cloud,name=loop4] at @s run scoreboard players set @a[distance=..1,gamemode=!spectator,scores={loop=3}] loop 4
execute as @e[type=area_effect_cloud,name=elytra] at @s run clear @a[distance=50..] elytra
execute as @e[type=minecraft:area_effect_cloud,name=end_button] at @s as @a[distance=..10,scores={loop=..3},gamemode=!spectator] run function sette:game/end_button
execute as @a[scores={loop=1}] run effect give @s absorption 4 2
execute as @a[scores={loop=2}] run effect give @s absorption 4 6
execute as @a[scores={loop=3}] run effect give @s absorption 4 11
execute as @a[scores={loop=4}] run effect give @s absorption 4 16
execute as @a[nbt={Inventory:[{id:"minecraft:elytra",Count:1b}]}] if score level stats matches 8 run 
execute if score level stats matches 8 as @a[scores={y=..90},nbt={Inventory:[{id:"minecraft:elytra",Count:1b}]}] run effect give @s resistance 2 100 true
execute if score level stats matches 8 as @a[scores={y=..90},nbt={Inventory:[{id:"minecraft:elytra",Count:1b}]}] run teleport @s -123 120 123

#nether
execute as @a[x=153,y=92,z=156,dx=0,dy=1,dz=0,gamemode=!spectator] unless score @s nether matches 1.. run tellraw @s ["",{"text":"I forgot that you can't put water in the nether","color":"red"}]
execute as @a[x=153,y=92,z=156,dx=0,dy=1,dz=0,gamemode=!spectator] run scoreboard players set @s nether 1
execute as @a[x=153,y=92,z=156,dx=0,dy=1,dz=0,gamemode=!spectator] run setblock 153 91 156 air

execute as @a[gamemode=spectator,scores={nether=1..}] run setblock 153 91 156 water
execute as @a[gamemode=spectator,scores={nether=1..}] run scoreboard players set @s nether 0

#ocean
scoreboard players set @a[scores={drown_timer=100..}] drown_timer 0
execute as @a[scores={drown_timer=1..}] at @s if score level stats matches 3 if block ~ ~ ~ air run scoreboard players remove @s drown_timer 1
execute as @a[gamemode=!spectator] if score level stats matches 3 if score @s y matches 90..91 at @s if block ~ ~ ~ water run scoreboard players add @s drown_timer 1
function sette:game/drowning


#forced ending
replaceitem entity @a[gamemode=adventure] hotbar.8 minecraft:ender_pearl{display:{Name:'{"text":"End Game","color":"red","italic":false}',Lore:['{"text":"Throw twice to","color":"dark_purple","italic":false}','{"text":"end the game","color":"dark_purple","italic":false}']}} 1
execute as @a[scores={ender_pearl=1}] at @s run tellraw @s ["",{"text":"Are you sure you want to end the game?","color":"aqua"},{"text":"\n"},{"text":"Throw again to confirm","color":"aqua"}]
execute as @a[scores={ender_pearl=1}] at @s run scoreboard players set @s ender_pearl 2
execute as @a[scores={ender_pearl=3}] at @s run tellraw @a ["",{"selector":"@a[scores={ender_pearl=3..}]","color":"red"},{"text":" ended the game","color":"red"}]
execute as @a[scores={ender_pearl=3}] at @s run function sette:end
kill @e[type=item,nbt={Item:{id:"minecraft:ender_pearl"}}]
kill @e[type=ender_pearl]


#end game
execute if score playerCount stats matches 0 run scoreboard players add end stats 1

execute if score end stats matches 10 run function sette:end


